;*******************************************************************
;				BraMo301.ASM
;	
;	tel.:Ericsson
;	Xtal=3,579Hz
;	IC=1,116us
;
;*******************************************************************

	LIST P=16C56,R=DEC


;registry mikroprocesoru

nulreg		equ	00
rtcc		equ	01	;reg. citace
pc		equ	02	;citac instrukci
status		equ	03	;reg.
fsr		equ	04	;reg. neprimeho adresovani
porta		equ	05	;reg. portu A
portb		equ	06	;reg. portu B


;registry uzivatele

rxdat		equ	08	;prac.registr pro ukldn pijmutch dat
citac		equ	09	;pomocn ta
txdat		equ	10	;prac.reg.pro vyslan data
pocbit		equ	11	;potadlo odvyslanch bit
prac1		equ	12	;pomocn registr 1
prac2		equ	13	;                2
prac3		equ	14	;                3
rosms		equ	15	;reg. odeslanch SMS zprv
sr		equ	16	;stavov registr (pomocn)


;definice symbol

#define		c	3,0	;CARRY bit v SWR
#define		rx	porta,0	;vstup Rx
#define		tx	porta,1	;vstup Tx
#define		ho	h'4f'	;hodnota ASCI "O" v HEXa
#define		ha	h'41'	;	      "A"  		
#define		ht	h'54'	;             "T"
#define		hc	h'43'	;             "C"
#define		hp	h'50'	;             "P"
#define		hd	h'44'	;             "D"
#define		hrovno	h'3d'	;             "rovno"
#define		hent	h'0d'	;             "ENTER"
#define		hclr	h'63'	;             "CLR"
#define		hvlevo	h'3c'	;             "vlevo"
#define		hvpravo	h'3e'	;             "vpravo"
#define		huvoz	h'22'	;             "uvoz"
#define		hyes	h'73'	;             "yes""s"
#define		hno	h'65'	;             "no""e"
#define		hk	h'4b'	;             "K"
#define		hplus	h'2b'	;             "plus"
#define		tl	porta,2
#define		led	porta,3
#define		j1	portb,0
#define		j2	portb,1
#define		j3	portb,2
#define		j4	portb,3
#define		j5	portb,4
#define		j6	portb,5
#define		j7	portb,6
#define		j8	portb,7


		org	00
		goto	start


scirx		bsf	c	
		clrf	rxdat
		rrf	rxdat,f
s1		btfsc	rx	;test na start bit
		goto	s1
 		movlw	14	;casovn 52us (Tbit/2)
		movwf	citac	;poad.as (us)-4IC/3IC
st05		decfsz	citac,f
		goto	st05
st1 		movlw	27	;casovn 104us (Tbit)
		movwf	citac	;poad.as (us)-12IC/3IC
st1a		decfsz	citac,f
		goto	st1a
		btfsc	rx	;vzorkovn RX
		goto	sch
		bcf	c
		goto	s2
sch		bsf	c
s2		rrf	rxdat,f
		btfss	c	;test na konec byte
		goto	st1
 		movlw	27	;casovn 104us (Tbit)-as pro dobhnut byte
		movwf	citac	;poad.as (us)-12IC/3IC
st1b		decfsz	citac,f
		goto	st1b
		return		;pijat data jsou uloena v RXDAT


scitx		bsf	tx	;v TXDAT mus bt data pro vysln
		movlw	9	;do POCBITu 9
		movwf	pocbit
		bcf	tx	;start bit
st31 		movlw	27	;casovn 104us (Tbit)
		movwf	citac	;poad.as (us)-12IC/3IC
st31a		decfsz	citac,f
		goto	st31a
		decfsz	pocbit,f;test na konec odvys. bytu
		goto	s51
		bsf	tx	;stop bit
 		movlw	31	;casovn 104us (Tbit)=dlka stop bitu
		movwf	citac	;poad.as (us)-2IC/3IC
st32		decfsz	citac,f
		goto	st32
		return
s51		rrf	txdat,f
		btfsc	c	;test na stav aktulnho bitu
		goto	s4h
		bcf	tx
		goto	s41
s4h		bsf	tx
s41		goto	st31


;podprogram pro asov interval 147ms.

t147		movlw	b'11000111'	;pd=256,rtcc=128,citac=4
		option
		clrf	citac
b147		clrf	rtcc
a147		btfss	rtcc,7
		goto	a147
		incf	citac,1
		btfss	citac,2
		goto	b147
		return


;podprogram pro asov interval asi 1,2s.

t1s		movlw	b'11000111'	;pd=256,rtcc=128,citac=32
		option
		clrf	citac
skokb		clrf	rtcc
skoka		btfss	rtcc,7
		goto	skoka
		incf	citac,1
		btfss	citac,5
		goto	skokb
		return


;podpr. prodlevy po stisknut tlatka MT

castl		movlw	5
		movwf	prac3
castl1		call	t147
		decfsz	prac3,f
		goto	castl1
		return


ckpd		movlw	ha		;odele na SCI AT+CKPD=
		movwf	txdat
		call	scitx
		movlw	ht
		movwf	txdat
		call	scitx
		movlw	hplus
		movwf	txdat
		call	scitx
		movlw	hc
		movwf	txdat
		call	scitx
		movlw	hk
		movwf	txdat
		call	scitx
		movlw	hp
		movwf	txdat
		call	scitx
		movlw	hd
		movwf	txdat
		call	scitx
		movlw	hrovno
		movwf	txdat
		call	scitx
		return


vlevo		movlw	hvlevo
		movwf	txdat
		call	scitx
		return


vpravo		movlw	hvpravo
		movwf	txdat
		call	scitx
		return


uvoz		movlw	huvoz
		movwf	txdat
		call	scitx
		return


yes		movlw	hyes
		movwf	txdat
		call	scitx
		return


no		movlw	hno
		movwf	txdat
		call	scitx
		return


ent		movlw	hent
		movwf	txdat
		call	scitx
		return


clr		movlw	hclr
		movwf	txdat
		call	scitx
		return
		

start		movlw	b'00000101'
		tris	porta		;ini PORT A
		movlw	b'11111111'
		tris	portb		;ini PORT B
		movlw	b'00001010'	
		movwf	porta		;stav PORT A
		movlw	b'11111111'
		movwf	portb		;stav PORT B
		movlw	0		
		movwf	sr		;stav SR


;st START 

start2		bsf	led		;zhas.led
		btfss	rx		;test na pip.mobil
		goto	start2
		call	t1s		
		
		movlw	ha		;odesln "AT" do mobilu
		movwf	txdat
		call	scitx
		movlw	ht
		movwf	txdat
		call	scitx		
		call	ent
		call	scirx		;dotaz na pchod "odpovdi"
		clrz
		movlw	b'11111111'
		subwf	rxdat,w
		skpnz		
		goto	start2		;nepila platna odpov z mobilu	
		
		bcf	led		;rosvcen led
		call	t1s

		clrf	rosms		;naten pedvolby do ROSMS
		btfss	portb,0
		bsf	rosms,0
		btfss	portb,1
		bsf	rosms,1
		btfss	portb,2
		bsf	rosms,2
		btfss	portb,3
		bsf	rosms,3
		btfss	portb,4
		bsf	rosms,4
		btfss	portb,5
		bsf	rosms,5
		btfss	portb,6
		bsf	rosms,6
		bcf	rosms,7

start4		btfss	tl		;test na stisknut tlatka
		goto	start3
		btfss	rx		;test na pipojen MT
		goto	start
		bcf	sr,0		;uvolnn SRb0 pro dal odesln SMS		
		call	t147
		goto	start4

start3		btfsc	sr,0		;ekn na uvolnn tlatka
		goto	start4
		btfss	portb,7		;test reimu "reakce na tlatko"
		bsf	sr,0
		
start5		call	ckpd		;znak <
		call	uvoz
		call	vlevo
		call	uvoz
		call	ent
		call	castl
		call	ckpd		;znak <
		call	uvoz
		call	vlevo
		call	uvoz
		call	ent
		call	castl
		call	ckpd		;znak <
		call	uvoz
		call	vlevo
		call	uvoz
		call	ent
		call	castl
		call	ckpd		;znak <
		call	uvoz
		call	vlevo
		call	uvoz
		call	ent
		call	castl
		call	ckpd		;znak <
		call	uvoz
		call	vlevo
		call	uvoz
		call	ent
		call	castl
		call	ckpd		;znak YES
		call	uvoz
		call	yes
		call	uvoz
		call	ent
		call	castl
		call	ckpd		;znak >
		call	uvoz
		call	vpravo
		call	uvoz
		call	ent
		call	castl
		call	ckpd		;znak YES
		call	uvoz
		call	yes
		call	uvoz
		call	ent
		call	castl
		call	ckpd		;znak YES
		call	uvoz
		call	yes
		call	uvoz
		call	ent
		call	castl
		call	ckpd		;znak <
		call	uvoz
		call	vlevo
		call	uvoz
		call	ent
		call	castl

		btfsc	rosms,0		;test volby 1. tel. .
		goto	o1tc
		btfsc	rosms,1		;test volby 2. tel. .
		goto	o2tc
		btfsc	rosms,2		;test volby 3. tel. .
		goto	o3tc
		btfsc	rosms,3		;test volby 4. tel. .
		goto	o4tc
		btfsc	rosms,4		;test volby 5. tel. .
		goto	o5tc
		btfsc	rosms,5		;test volby 6. tel. .
		goto	o6tc
		btfsc	rosms,6		;test volby 7. tel. .
		goto	o7tc

konod		movlw	10		;ekej 10s
		movwf	prac1
konod1		call	t1s
		decfsz	prac1,f
		goto	konod1
		call	ckpd		;znak CLR
		call	uvoz
		call	clr
		call	uvoz
		call	ent
		call	castl
		movlw	0		;test na ROSMS=0
		clrz
		subwf	rosms,w
		skpz
		goto	start3
		goto	start2

o1tc		bcf	rosms,0		;odely SMS na 1. tel. slo
		movlw	1
		movwf	prac2		
o1tc1		call	ckpd
		call	uvoz
		call	vpravo
		call	uvoz
		call	ent
		call	castl
		decfsz	prac2,f
		goto	o1tc1
		call	castl
		call	ckpd		
		call	uvoz
		call	yes
		call	uvoz
		call	ent
		call	castl
		goto	konod

o2tc		bcf	rosms,1		;odely SMS na 2. tel. slo
		movlw	2
		movwf	prac2		
o2tc1		call	ckpd
		call	uvoz
		call	vpravo
		call	uvoz
		call	ent
		call	castl
		decfsz	prac2,f
		goto	o2tc1
		call	castl
		call	ckpd		
		call	uvoz
		call	yes
		call	uvoz
		call	ent
		call	castl
		goto	konod

o3tc		bcf	rosms,2		;odely SMS na 3. tel. slo
		movlw	3
		movwf	prac2		
o3tc1		call	ckpd
		call	uvoz
		call	vpravo
		call	uvoz
		call	ent
		call	castl
		decfsz	prac2,f
		goto	o3tc1
		call	castl
		call	ckpd		
		call	uvoz
		call	yes
		call	uvoz
		call	ent
		call	castl
		goto	konod

o4tc		bcf	rosms,3		;odely SMS na 4. tel. slo
		movlw	4
		movwf	prac2		
o4tc1		call	ckpd
		call	uvoz
		call	vpravo
		call	uvoz
		call	ent
		call	castl
		decfsz	prac2,f
		goto	o4tc1
		call	castl
		call	ckpd		
		call	uvoz
		call	yes
		call	uvoz
		call	ent
		call	castl
		goto	konod

o5tc		bcf	rosms,4		;odely SMS na 5. tel. slo
		movlw	5
		movwf	prac2		
o5tc1		call	ckpd
		call	uvoz
		call	vpravo
		call	uvoz
		call	ent
		call	castl
		decfsz	prac2,f
		goto	o5tc1
		call	castl
		call	ckpd		
		call	uvoz
		call	yes
		call	uvoz
		call	ent
		call	castl
		goto	konod

o6tc		bcf	rosms,5		;odely SMS na 6. tel. slo
		movlw	6
		movwf	prac2		
o6tc1		call	ckpd
		call	uvoz
		call	vpravo
		call	uvoz
		call	ent
		call	castl
		decfsz	prac2,f
		goto	o6tc1
		call	castl
		call	ckpd		
		call	uvoz
		call	yes
		call	uvoz
		call	ent
		call	castl
		goto	konod

o7tc		bcf	rosms,6		;odely SMS na 7. tel. slo
		movlw	7
		movwf	prac2		
o7tc1		call	ckpd
		call	uvoz
		call	vpravo
		call	uvoz
		call	ent
		call	castl
		decfsz	prac2,f
		goto	o7tc1
		call	castl
		call	ckpd		
		call	uvoz
		call	yes
		call	uvoz
		call	ent
		call	castl
		goto	konod


		end
